local util = include( "modules/util" )
local commondefs = include( "sim/unitdefs/commondefs" )
local simdefs = include("sim/simdefs")
local speechdefs = include("sim/speechdefs")
local SCRIPTS = include('client/story_scripts')
local DEFAULT_DRONE = commondefs.DEFAULT_DRONE
local SOUNDS = commondefs.SOUNDS

local SOMBRA_SOUNDS =
{
	bio = "",
	escapeVo = "",
	speech="SpySociety/Agents/dialogue_player",  
	step = simdefs.SOUNDPATH_FOOTSTEP_FEMALE_HARDWOOD_NORMAL, 
	stealthStep = simdefs.SOUNDPATH_FOOTSTEP_FEMALE_HARDWOOD_SOFT,
	wallcover = "SpySociety/Movement/foley_trench/wallcover",
	crouchcover = "SpySociety/Movement/foley_trench/crouchcover",
	fall = "SpySociety/Movement/foley_trench/fall",
	land = "SpySociety/Movement/deathfall_agent_hardwood",
	land_frame = 16,						
	getup = "SpySociety/Movement/foley_trench/getup",	
	grab = "SpySociety/Movement/foley_trench/grab_guard",
	pin = "SpySociety/Movement/foley_trench/pin_guard",
	pinned = "SpySociety/Movement/foley_trench/pinned",
	peek_fwd = "SpySociety/Movement/foley_trench/peek_forward",	
	peek_bwd = "SpySociety/Movement/foley_trench/peek_back",	
	move = "SpySociety/Movement/foley_trench/move",
	hit = "SpySociety/HitResponse/hitby_ballistic_flesh",
}

local agent_templates =
{
	sombra_1 =
	{
		type = "simunit",
        	agentID = "SOMBRA_001",
		name = STRINGS.TALON.AGENTS.SOMBRA.NAME,
		file =  STRINGS.TALON.AGENTS.SOMBRA.FILE,
		fullname = STRINGS.TALON.AGENTS.SOMBRA.ALT_1.FULLNAME,
		loadoutName = STRINGS.UI.ON_FILE,
		yearsOfService = STRINGS.TALON.AGENTS.SOMBRA.YEARS_OF_SERVICE,
		age = STRINGS.TALON.AGENTS.SOMBRA.AGE,
		homeTown = STRINGS.TALON.AGENTS.SOMBRA.HOMETOWN,
		gender = "female",
		class = "Stealth",
		toolTip = STRINGS.TALON.AGENTS.SOMBRA.ALT_1.TOOLTIP,
		onWorldTooltip = commondefs.onAgentTooltip,
		
		profile_icon_36x36= "gui/profile_icons/sombra_36.png",
		profile_icon_64x64= "gui/profile_icons/sombra1_64x64.png",
		splash_image = "gui/profile_icons/sombra_1024.png",
		profile_anim = "portraits/lady_tech_face",
		profile_build = "portrait_sombra",
		team_select_img = {
			"gui/profile_icons/team_select_1_sombra.png"
		},
		kanim = "kanim_sombra",
		hireText = STRINGS.TALON.AGENTS.SOMBRA.RESCUED,
		centralHireSpeech = SCRIPTS.INGAME.CENTRAL_AGENT_ESCAPE_BANKS,
		traits = util.extend( commondefs.DEFAULT_AGENT_TRAITS ) { mp=8, mpMax =8 },	--passiveKey = simdefs.DOOR_KEYS.SECURITY
		skills = util.extend( commondefs.DEFAULT_AGENT_SKILLS ) {}, 
		startingSkills = { stealth = 2 },
		abilities = util.tconcat( { "sprint",  }, commondefs.DEFAULT_AGENT_ABILITIES ), -- "stealthSprint"
		--abilities = { "shootOverwatch", "sombra_jackin", "overwatch", "peek", "escape", "melee", "disarmtrap", "overwatchMelee" , "meleeOverwatch", "observePath", "moveBody", "lastWords", "sprint"  },
		children = { }, -- Dont add items here, add them to the upgrades table in createDefaultAgency()
		sounds = SOMBRA_SOUNDS,
		speech = STRINGS.TALON.AGENTS.SOMBRA.BANTER,
		blurb = STRINGS.TALON.AGENTS.SOMBRA.ALT_1.BIO,
		upgrades = { "augment_sombra", "item_tazer_sombra", "item_translocator" , --[==["item_cloakingrig_sombra",]==] },
	},
}

return agent_templates