local util = include( "modules/util" )
local commondefs = include( "sim/unitdefs/commondefs" )
local simdefs = include("sim/simdefs")
local speechdefs = include("sim/speechdefs")
local SCRIPTS = include('client/story_scripts')
local DEFAULT_DRONE = commondefs.DEFAULT_DRONE
local SOUNDS = commondefs.SOUNDS

local WIDOWMAKER_SOUNDS =
{
	bio = "",
	escapeVo = "",
	speech="SpySociety/Agents/dialogue_player",  
	step = simdefs.SOUNDPATH_FOOTSTEP_FEMALE_HARDWOOD_NORMAL, 
	stealthStep = simdefs.SOUNDPATH_FOOTSTEP_FEMALE_HARDWOOD_SOFT, 
	wallcover = "SpySociety/Movement/foley_trench/wallcover",
	crouchcover = "SpySociety/Movement/foley_trench/crouchcover",
	fall = "SpySociety/Movement/foley_trench/fall",
	land = "SpySociety/Movement/deathfall_agent_hardwood",
	land_frame = 16,						
	getup = "SpySociety/Movement/foley_trench/getup",	
	grab = "SpySociety/Movement/foley_trench/grab_guard",
	pin = "SpySociety/Movement/foley_trench/pin_guard",
	pinned = "SpySociety/Movement/foley_trench/pinned",
	peek_fwd = "SpySociety/Movement/foley_trench/peek_forward",	
	peek_bwd = "SpySociety/Movement/foley_trench/peek_back",	
	move = "SpySociety/Movement/foley_trench/move",
	hit = "SpySociety/HitResponse/hitby_ballistic_flesh",
}

local agent_templates =
{
	
	
	widowmaker_1 =
	{
		type = "simunit",
		agentID = "WIDOWMAKER_001",
		name =  STRINGS.TALON.AGENTS.WIDOWMAKER.NAME,
		file =  STRINGS.TALON.AGENTS.WIDOWMAKER.FILE,
		fullname =  STRINGS.TALON.AGENTS.WIDOWMAKER.ALT_1.FULLNAME,
		loadoutName = STRINGS.UI.ON_FILE,
		yearsOfService =  STRINGS.TALON.AGENTS.WIDOWMAKER.YEARS_OF_SERVICE,
		age = STRINGS.TALON.AGENTS.WIDOWMAKER.AGE,
		homeTown = STRINGS.TALON.AGENTS.WIDOWMAKER.HOMETOWN,
		gender = "female",
		class = "Sharpshooter",
		toolTip = STRINGS.TALON.AGENTS.WIDOWMAKER.ALT_1.TOOLTIP,
		onWorldTooltip = commondefs.onAgentTooltip,

		profile_icon_36x36= "gui/profile_icons/widow_36.png",
		profile_icon_64x64= "gui/profile_icons/widow1_64x64.png",
		splash_image = "gui/profile_icons/widowmaker_1024.png",
		profile_anim = "portraits/lady_sharpshooter_face",	
		profile_build = "portrait_widowmaker",
		team_select_img = {
			"gui/profile_icons/team_select_1_widowmaker.png"
		},

		kanim = "kanim_widowmaker",
		hireText = STRINGS.AGENTS.NIKA.RESCUED,
		centralHireSpeech = SCRIPTS.INGAME.CENTRAL_AGENT_ESCAPE_NIKA,
		traits = util.extend( commondefs.DEFAULT_AGENT_TRAITS ) { shields = 0, shieldsMax = 0, mp=8, mpMax = 8 },
		skills = util.extend( commondefs.DEFAULT_AGENT_SKILLS ) {}, 
		startingSkills = {  },
		abilities = util.tconcat( { "sprint",  }, commondefs.DEFAULT_AGENT_ABILITIES ),
		children = {}, -- Dont add items here, add them to te upgrades table in createDefaultAgency()
		sounds = WIDOWMAKER_SOUNDS,
		speech = STRINGS.TALON.AGENTS.WIDOWMAKER.BANTER,
		blurb = STRINGS.TALON.AGENTS.WIDOWMAKER.ALT_1.BIO,
		upgrades = { "augment_widowmaker", "item_widowsgun", "item_venommine" },	
		logs = {},
	},
}

return agent_templates