local simquery = include( "sim/simquery" )

--------------------------------------------------------------------------

local old_calculateShotSuccess = simquery.calculateShotSuccess

local function editWidowPierce(sim, sourceUnit, val)
	if sourceUnit._children then
		for i,child in ipairs(sourceUnit._children) do		
			if child:getTraits()[ "isWidowAug" ] then
				child:getTraits().addArmorPiercingRanged = val	
			end
		end
	end
end

function simquery.calculateShotSuccess( sim, sourceUnit, targetUnit, equipped )
	
	local widowTagged = false
	if sourceUnit and sourceUnit:getTraits().hasWidowmakerAug and
		targetUnit and (targetUnit:getTraits().patrolObserved or targetUnit:getTraits().tagged) then
		widowTagged = true
	end
	
	if widowTagged then
		editWidowPierce(sim, sourceUnit, 1)
	end
	
	local success = old_calculateShotSuccess( sim, sourceUnit, targetUnit, equipped )
	
	if widowTagged then
		editWidowPierce(sim, sourceUnit, 0)
	end
	
	return success
end