local array = include( "modules/array" )
local util = include( "modules/util" )
local cdefs = include( "client_defs" )
local simdefs = include("sim/simdefs")
local simquery = include("sim/simquery")
local inventory = include("sim/inventory")
local abilityutil = include( "sim/abilities/abilityutil" )
local mathutil = include( "modules/mathutil" )
local speechdefs = include("sim/speechdefs")
local serverdefs = include( "modules/serverdefs" )





local sombra_hack =
{
	name = STRINGS.TALON.ABILITIES.EMP.NAME,
	profile_icon = "gui/icons/Talon/icon-item_sombra_hijack_small.png", 
	usesAction = true,
	usesMP = true,
	--local mpCost, CPUCost, curRange = self:calculateCosts( sim, abilityOwner, abilityUser, targetUnit, targetUnitID )
	--cpu_cost = STRINGS.TALON.ABILITIES.EMP.CPUCOST,
	mp_cost = STRINGS.TALON.ABILITIES.EMP.MPCOST,
	--traits = { pwrCost = 2, mp_cost = 2 },
	pwrCost = STRINGS.TALON.ABILITIES.EMP.PWRCOST,

	
		onTooltip = function( self, hud, sim, abilityOwner, abilityUser, targetUnitID )
			local tooltip = util.tooltip( hud._screen )
			local section = tooltip:addSection()
			local canUse, reason = abilityUser:canUseAbility( sim, self, abilityOwner, targetUnitID )		
			local targetUnit = sim:getUnit( targetUnitID )
			
	        section:addLine( util.toupper( self:getTargName( sim, abilityOwner, abilityUser, targetUnitID ) ) )
			if targetUnit then
			--	if abilityOwner:getTraits().PWR_conversion then 
			section:addAbility( self:writeCosts(sim, abilityOwner, abilityUser, targetUnitID),
								util.sformat(STRINGS.TALON.ABILITIES.EMP.TOOLTIP_INFO, abilityOwner:getName()), "gui/items/icon-action_hack-console.png" )
			--	end
			end
			if reason then
				section:addRequirement( reason )
			end
			
			local mpCost, CPUCost, curRange, bonus = self:calculateCosts( sim, abilityOwner, abilityUser, targetUnit, targetUnitID )
			
			activate = function ()
				self._game = hud._game
				self._game.hud:previewAbilityAP( abilityUser._unit, mpCost )
			end
			
			deactivate = function ()
				self._game = hud._game
				self._game.hud:previewAbilityAP( abilityUser._unit, 0 )
			end
			
			
			return tooltip
		end,


		getName = function( self, sim, unit )
			return self.name
		end,
		
		getTargName = function( self, sim, abilityOwner, abilityUser, targetUnitID  )
			local targetUnit = sim:getUnit( targetUnitID )
			
			if targetUnit then
                local mpCost, CPUCost, curRange, bonus = self:calculateCosts( sim, abilityOwner, abilityUser, targetUnit, targetUnitID )
				
				if targetUnit:getTraits().mainframe_console and (targetUnit:getTraits().cpus or 0) > 0 then
					return util.sformat( STRINGS.TALON.ABILITIES.EMP.CAPTURE_NAME, util.toupper( targetUnit:getName() ) ) -- cam captures are quiet
				elseif targetUnit:getTraits().mainframe_camera and targetUnit:getTraits().mainframe_status == "off" then
					return util.sformat( STRINGS.TALON.ABILITIES.EMP.CAPTURE_NAME, util.toupper( targetUnit:getName() ) ) -- cam captures are quiet
				else
					return util.sformat( STRINGS.TALON.ABILITIES.EMP.HACK_NAME, util.toupper( targetUnit:getName() ) )
				end
			else
			return string.format( STRINGS.ABILITIES.HIJACK_CONSOLE_INSTALL_VIRUS)
			end
		
		end,		
		
		
		writeCosts = function( self,sim, abilityOwner, abilityUser, targetID )
			local targetUnit = sim:getUnit( targetID )
			local targetUnitID = targetID
			--return util.sformat( STRINGS.ABILITIES.MANUAL_SHUTDOWN_DESC, util.toupper( targetUnit:getName() ),1)
			--local targetUnit = sim:getUnit( targetUnitID )
			if targetUnit then
                local mpCost, CPUCost, curRange, bonus = self:calculateCosts( sim, abilityOwner, abilityUser, targetUnit, targetUnitID )
				
				if targetUnit:getTraits().mainframe_console and (targetUnit:getTraits().cpus or 0) > 0 then
					return util.sformat( STRINGS.TALON.ABILITIES.EMP.CAPTURE_CONSOLE, CPUCost, bonus, mpCost ) -- console captures are quiet
				elseif targetUnit:getTraits().mainframe_camera and targetUnit:getTraits().mainframe_status == "off" then
					return util.sformat( STRINGS.TALON.ABILITIES.EMP.CAPTURE_CAM, util.toupper( targetUnit:getName() ), CPUCost, mpCost ) -- cam captures are quiet
				else
					if curRange < 1.5 then
						return util.sformat( STRINGS.TALON.ABILITIES.EMP.NOISE_LVL1, util.toupper( targetUnit:getName() ), CPUCost, mpCost )  -- quiet
					end
					if curRange > 1.5 and curRange < 2.5 then
						return util.sformat( STRINGS.TALON.ABILITIES.EMP.NOISE_LVL2, util.toupper( targetUnit:getName() ), CPUCost, mpCost ) -- med noise
					end
					if curRange > 2.5 then
						return util.sformat( STRINGS.TALON.ABILITIES.EMP.NOISE_LVL3, util.toupper( targetUnit:getName() ), CPUCost, mpCost ) -- high noise
					end
				end
			end
		end,
		
		

		
		
			
		
		calculateCosts = function( self, sim, abilityOwner, unit, targetUnit, targetUnitID )
			if self:isTarget( sim, abilityOwner, unit, targetUnit ) then

				local mainframe = include( "sim/mainframe" )
				local target = sim:getUnit(targetUnitID)			
				local x0,y0 = abilityOwner:getLocation()
				local x1,y1 = target:getLocation()
				
				local curRange = math.ceil(mathutil.dist2d( x0, y0, x1, y1 ))  -- Closer = quieter but higher AP. Costs 1 power per level so weaken systems first.
				local iceCount = target:getTraits().mainframe_ice
				local hackProx = curRange -- closer is lower - up to free - diags = 1
				
				
				local CPUCost = 99
				local mpCost = 99
				local bonus = 99
				
				if targetUnit:getTraits().mainframe_console then	
					 CPUCost = (targetUnit:getTraits().cpus or 0)
					 mpCost = math.min(math.max(4 - hackProx, 1), 3)
					 bonus = (unit:getTraits().hacking_bonus or 0) + 1
				else
					 CPUCost = iceCount
					 mpCost = math.min(math.max(4 - hackProx, 1), 3)
					 bonus = 0
				end
				
				--local player = abilityOwner:getPlayerOwner()

				if unit ~= abilityOwner then
					CPUCost = CPUCost
					mpCost = mpCost
					curRange = curRange
					bonus = bonus + (abilityOwner:getTraits().hacking_bonus or 0)
				end			
				
				return mpCost, CPUCost, curRange, bonus
			end
		end,
		
		
		isTarget = function( self, sim, abilityOwner, userUnit, targetUnit )
		
			if (targetUnit:getTraits().mainframe_ice or 0) > 0 and targetUnit:getTraits().mainframe_status ~= "off" then
					return true
			end
			
			if (targetUnit:getTraits().mainframe_ice or 0) > 0 and targetUnit:getTraits().mainframe_camera and targetUnit:getTraits().mainframe_status == "off" then -- can capture inactive cams
				return true
			end
			
			if targetUnit:getTraits().mainframe_console and (targetUnit:getTraits().cpus or 0) > 0 then
				return true
			end

			return false
		end,
		
		
		
		
		acquireTargets = function( self, targets, game, sim, abilityOwner, unit )

			local maxRange = abilityOwner:getTraits().sombra_wireless_range
			if abilityOwner:getTraits().wireless_range then
				local maxRange = abilityOwner:getTraits().sombra_wireless_range + (abilityOwner:getTraits().wireless_range / 2)
			end
			local x0, y0 = unit:getLocation()
			local units = {}
			for _, targetUnit in pairs(sim:getAllUnits()) do
				local x1, y1 = targetUnit:getLocation()
				if x1 and self:isTarget( sim, abilityOwner, unit, targetUnit ) then
					local range = mathutil.dist2d( x0, y0, x1, y1 )
					if maxRange then
						-- This handles wireless jack-ins.
						if range <= maxRange then
							targetUnit = unit:getPlayerOwner():getLastKnownUnit( sim, targetUnit:getID() )
							if targetUnit:isGhost() or sim:canPlayerSeeUnit( unit:getPlayerOwner(), targetUnit ) then
								table.insert( units, targetUnit )
							end
						end
			--[==[		else
						-- This handles manual jacking. (heh)
						if range <= 1 and simquery.isConnected( sim, sim:getCell( x0, y0 ), sim:getCell( x1, y1 ) ) then
							table.insert( units, targetUnit )
						end
				]==]
					end
				end
			end

			return targets.unitTarget( game, units, self, abilityOwner, unit )
		end,


		
		
	canUseAbility = function( self, sim, abilityOwner, unit, targetUnitID )
	
		local targetUnit = sim:getUnit( targetUnitID )
			
		if abilityOwner:getAP() < 1 then 
			return false, STRINGS.UI.REASON.ATTACK_USED
		end 

		if abilityOwner:getTraits().cooldown and abilityOwner:getTraits().cooldown > 0 then
			return false, util.sformat(STRINGS.UI.REASON.COOLDOWN,abilityOwner:getTraits().cooldown)
		end

		if abilityOwner:getTraits().usesCharges and abilityOwner:getTraits().charges < 1 then
			return false, util.sformat(STRINGS.UI.REASON.CHARGES)
		end			
		
	--	if sim:canPlayerSeeUnit( sim:getNPC(), abilityOwner ) then       -- From Cloak - Cannot hack when seen
	--				return false, STRINGS.TALON.ABILITIES.EMP.IN_DANGER
	--	end
			
		if targetUnit then    -- target Unit Variables!
		log:write( "targ" )
			local los = false
			if sim:canUnitSeeUnit( abilityOwner, targetUnit ) then
				los = true
				log:write( "loooss" )
			end
			if not los then
				for _, cameraUnit in pairs(sim:getAllUnits()) do 
				log:write( "beep" )
					if cameraUnit:getTraits().peekID == abilityOwner:getID() and sim:canUnitSeeUnit( cameraUnit, targetUnit ) then
						los = true
						log:write( "BOOP" )
					end
				end
			end
			if not los then
				return false, STRINGS.TALON.ABILITIES.EMP.REQ_LOS
			end
			
			local mpCost, CPUCost, curRange, bonus = self:calculateCosts( sim, abilityOwner, unit, targetUnit, targetUnitID )
			
			if abilityOwner:getTraits().mp < mpCost then
				return false, util.sformat(STRINGS.TALON.ABILITIES.EMP.NOT_ENOUGH_AP,mpCost)
			end
			
			if targetUnit:getTraits().mainframe_console then
				
				assert( self:isTarget( sim, abilityOwner, unit, targetUnit ))
				if targetUnit:getTraits().mainframe_console_lock > 0 then
					return false, STRINGS.UI.REASON.CONSOLE_LOCKED
				end
				
			else
				
				if abilityOwner:getPlayerOwner():getCpus() < CPUCost then
					return false, util.sformat(STRINGS.TALON.ABILITIES.EMP.NOT_ENOUGH_CPU,CPUCost,targetUnit:getName())
				end			
				
		---		if targetUnit:getTraits().mainframe_ice > 3 then
		---			return false, STRINGS.TALON.ABILITIES.EMP.REQ_LOS   -- target 3 ice or lower
		---		end
			end
		end
			
		return abilityutil.checkRequirements( unit, abilityOwner)
	end,
	
				
	
	executeAbility = function( self, sim, abilityOwner, unit, targetUnitID )

		local mainframe = include( "sim/mainframe" )
		local target = sim:getUnit(targetUnitID)			
		local x0,y0 = abilityOwner:getLocation()
		local x1,y1 = target:getLocation()
  		local newFacing = simquery.getDirectionFromDelta(x1-x0,y1-y0) 

			--- effects
		abilityOwner:setInvisible(false)
		abilityOwner:setDisguise(false)

		
		local targetUnit = sim:getUnit( targetUnitID )
		
		local mpCost, CPUCost, curRange, bonus = self:calculateCosts( sim, abilityOwner, unit, targetUnit, targetUnitID )
		
		
		abilityOwner:useAP( sim )
		abilityOwner:useMP(mpCost, sim)
		
		if targetUnit then    -- target Unit Variables!
			if targetUnit:getTraits().mainframe_console then
			
				targetUnit:getTraits().hijacked = true
                targetUnit:getTraits().mainframe_suppress_range = nil
				targetUnit:setPlayerOwner(abilityOwner:getPlayerOwner())			
			    targetUnit:getTraits().cpus = 0
				
				sim:dispatchEvent( simdefs.EV_UNIT_WIRELESS_SCAN, { unitID = unit:getID(), targetUnitID = target, hijack = true } )
				target:processEMP( 1 )
				
				local player = abilityOwner:getPlayerOwner()
				player:addCPUs( CPUCost + bonus )
				
			else  --- not a console

			local player = abilityOwner:getPlayerOwner()
			player:addCPUs( 0 - CPUCost )
			local CPUCostRational = CPUCost
			sim:dispatchEvent( simdefs.EV_UNIT_FLOAT_TXT, {txt=util.sformat(STRINGS.TALON.ABILITIES.EMP.NEG_PWR, CPUCostRational), x=x1,y=y1, color=cdefs.AUGMENT_TXT_COLOR} )
			
				if targetUnit:getTraits().mainframe_camera and targetUnit:getTraits().mainframe_status == "off" then
					targetUnit:getTraits().mainframe_status = "active"
					targetUnit:setPlayerOwner(abilityOwner:getPlayerOwner())			
					targetUnit:getTraits().icebreak = 0
					
					target:processEMP( 1 )
				
				else
				
					if curRange < 1.5 then
						local facing = simquery.getDirectionFromDelta( x1 - x0, y1 - y0 )
						sim:dispatchEvent( simdefs.EV_UNIT_USECOMP, { unitID = unit:getID(), targetID= targetUnit:getID(), facing = facing, sound=simdefs.SOUNDPATH_USE_CONSOLE, soundFrame=10 } )
					end
					if curRange > 1.5 and curRange < 2.5 then
						sim:emitSound( simdefs.SOUND_SMALL, x1, y1, unit)  -- EMP has 2 tile radius on user
						sim:dispatchEvent( simdefs.EV_UNIT_WIRELESS_SCAN, { unitID = unit:getID(), targetUnitID = targetUnitID, hijack = true } )
					end
					if curRange > 2.5 then
						sim:emitSound( simdefs.SOUND_EMP_EXPLOSION, x1, y1, unit) 
						sim:dispatchEvent( simdefs.EV_UNIT_WIRELESS_SCAN, { unitID = unit:getID(), targetUnitID = targetUnitID, hijack = true } )
					end
					
					target:processEMP( 1 )
				end
			end
		end
		--sim:addTrigger( simdefs.TRG_END_TURN, self )  -- trigger EMP at end of turn
	end,
	

	
	
}
return sombra_hack


