local array = include( "modules/array" )
local util = include( "modules/util" )
local mathutil = include( "modules/mathutil" )
local cdefs = include( "client_defs" )
local simdefs = include("sim/simdefs")
local simquery = include("sim/simquery")
local inventory = include("sim/inventory")
local speechdefs = include("sim/speechdefs")
local abilityutil = include( "sim/abilities/abilityutil" )
local mathutil = include( "modules/mathutil" )
local unitdefs = include("sim/unitdefs")
local simfactory = include( "sim/simfactory" )
local itemdefs = include("sim/unitdefs/itemdefs")
local guarddefs = include("sim/unitdefs/guarddefs")
local propdefs = include("sim/unitdefs/propdefs")








local sombra_throw_translocator =
	{
		name = STRINGS.ABILITIES.THROW,

		getName = function( self, sim, unit, userUnit )
			return self.name
		end,
	
		createToolTip = function( self,sim,unit,targetCell)
			return abilityutil.formatToolTip( STRINGS.ABILITIES.THROW,  STRINGS.ABILITIES.THROW_DESC, 1 )
		end,
		
		--onTooltip = function( self, hud, sim, abilityOwner, abilityUser )
		--	return sombThrow_tooltip( hud, abilityUser, abilityOwner:getTraits().range, self, sim, abilityOwner, STRINGS.ABILITIES.CLOAK_DESC )
		--end,
	
		profile_icon = "gui/icons/action_icons/Action_icon_Small/icon-item_shoot_small.png",
		usesAction = true,

		acquireTargets = function( self, targets, game, sim, grenadeUnit, unit)
			if not self:canUseAbility( sim, grenadeUnit, unit ) then
				return nil
			end
			return targets.throwTarget( game, grenadeUnit:getTraits().range or 0, sim, unit, unit:getTraits().maxThrow, grenadeUnit:getTraits().targeting_ignoreLOS)
		end, 


		canUseAbility = function( self, sim, grenadeUnit, unit, targetCell )
		
            if unit:getTraits().movingBody then
                return false, STRINGS.UI.REASON.DROP_BODY_TO_USE
            end
			
			--local weaponUnit = grenadeUnit
			local ok, reason = abilityutil.canConsumeAmmo( sim, grenadeUnit )
            if not ok then
                return false
            end

			if grenadeUnit:getTraits().restrictedUse then

				local userUnitAgentID = unit:getUnitData().agentID
				local canUse =false
				for i,set in pairs(grenadeUnit:getTraits().restrictedUse )do
					if set.agentID == userUnitAgentID then
						canUse=true
					end
				end


				if not canUse then
					return false,  STRINGS.UI.REASON.RESTRUCTED_USE
				end				
			end

			if grenadeUnit:getTraits().cooldown and grenadeUnit:getTraits().cooldown > 0 then
				return false, util.sformat(STRINGS.UI.REASON.COOLDOWN,grenadeUnit:getTraits().cooldown)
			end

			if grenadeUnit:getTraits().usesCharges and grenadeUnit:getTraits().charges < 1 then
				return false, util.sformat(STRINGS.UI.REASON.CHARGES)
			end

			if grenadeUnit:getTraits().ammo <= 0 then
				return false, STRINGS.UI.REASON.NO_AMMO
			end

			if grenadeUnit:getTraits().pwrCost and unit:getPlayerOwner():getCpus() < grenadeUnit:getTraits().pwrCost then
				return false, util.sformat(STRINGS.UI.REASON.NOT_ENOUGH_PWR)
			end

			if targetCell then
				local targetX,targetY = unpack(targetCell)
				local unitX, unitY = unit:getLocation()
	    		local raycastX, raycastY = sim:getLOS():raycast(unitX, unitY, targetX, targetY)
				if raycastX ~= targetX or raycastY ~= targetY then
					return false
				end
			end

			return true
		end,

		--[====[
		
		------------------
		onWarp = function(self, sim, oldcell, cell )
			if oldcell == nil then
				sim:addTrigger( simdefs.TRG_UNIT_WARP, self)
				--sim:addTrigger( simdefs.TRG_START_TURN, self )
				--sim:addTrigger( simdefs.TRG_OVERWATCH, self )

			elseif cell == nil then
				sim:removeTrigger( simdefs.TRG_UNIT_WARP, self)
				--sim:removeTrigger( simdefs.TRG_START_TURN, self )
				--sim:removeTrigger( simdefs.TRG_OVERWATCH, self )
			end
		end,
		]====]		
   
		-----------------
		
		
		onSpawnAbility = function( self, sim, unit )
			self.abilityOwner = unit
			sim:addTrigger( simdefs.TRG_END_TURN, self )
			sim:addTrigger( simdefs.TRG_START_TURN, self )
		end,
			
		onDespawnAbility = function( self, sim, unit )
			sim:removeTrigger( simdefs.TRG_END_TURN, self )
			sim:removeTrigger( simdefs.TRG_START_TURN, self )
			self.abilityOwner = nil
		end,
		
		onTrigger = function( self, sim, evType, evData, unit )
			if evType == simdefs.TRG_END_TURN and evData == sim:getCurrentPlayer() and evData:isPC() then
				sim:forEachUnit(
					function ( existingTrBeacon )
						local x1, y1 = existingTrBeacon:getLocation()
						if x1 and y1 and existingTrBeacon:getTraits().isTranslocatorBeacon then
							if existingTrBeacon:getTraits().beaconLife > 0 then
								existingTrBeacon:getTraits().beaconLife = existingTrBeacon:getTraits().beaconLife - 1
								sim:dispatchEvent( simdefs.EV_UNIT_REFRESH, { unit = existingTrBeacon, fx = "emp" } )	
							else
								local player = sim:getPC()
								beaconUnitID = existingTrBeacon:getID()	
								local cell = sim:getCell( existingTrBeacon:getLocation() )
								sim:dispatchEvent( simdefs.EV_CAM_PAN, { cell.x, cell.y } )	
								local x0,y0 = existingTrBeacon:getLocation()
								--sim:dispatchEvent( simdefs.EV_FLASH_VIZ, {x = x0, y = y0, units = nil, range = 1} )
								--sim:dispatchEvent( simdefs.EV_UNIT_APPEARED, { unitID = beaconUnitID, noSightingFx=true } )
								sim:dispatchEvent( simdefs.EV_UNIT_REFRESH, { unit = existingTrBeacon, fx = "emp" } )	
								sim:dispatchEvent( simdefs.EV_TELEPORT, { units={existingTrBeacon}, warpOut =true } )
								sim:warpUnit(existingTrBeacon, nil)
								sim:despawnUnit( existingTrBeacon )
								player:glimpseUnit(sim, beaconUnitID)
								sim:removeTrigger( simdefs.TRG_UNIT_WARP, self)
							end
						end
					end
				)
			end	
			if evType == simdefs.TRG_START_TURN and evData == sim:getCurrentPlayer() and evData:isPC() then
				sim:forEachUnit(
					function ( existingTrBeacon )
						local x1, y1 = existingTrBeacon:getLocation()
						if x1 and y1 and existingTrBeacon:getTraits().isTranslocatorBeacon then
							if existingTrBeacon:getTraits().beaconLife == 0 then
								local player = sim:getPC()
								beaconUnitID = existingTrBeacon:getID()	
								local cell = sim:getCell( existingTrBeacon:getLocation() )
								sim:dispatchEvent( simdefs.EV_CAM_PAN, { cell.x, cell.y } )	
								sim:dispatchEvent( simdefs.EV_UNIT_REFRESH, { unit = existingTrBeacon, fx = "emp" } )	
							end
						end
					end
				)
			end	
		end,
		
		--------------------
		
		executeAbility = function( self, sim, grenadeUnit, userUnit, targetCell )
			local sim = grenadeUnit:getSim()
			local x0,y0 = userUnit:getLocation()
					
			local x1,y1 = unpack(targetCell)
			local cell = sim:getCell( userUnit:getLocation() )
			userUnit:getTraits().throwing = true
		
			local facing = simquery.getDirectionFromDelta(x1-x0, y1-y0)
			simquery.suggestAgentFacing(userUnit, facing)
			if userUnit:getBrain() then	
				if grenadeUnit:getTraits().baseDamage then
					sim:emitSpeech(userUnit, speechdefs.HUNT_GRENADE)
				end
				sim:refreshUnitLOS( userUnit )
				sim:processReactions( userUnit )
			end

			if userUnit:isValid() and not userUnit:getTraits().interrupted then
			
				sim:dispatchEvent( simdefs.EV_UNIT_THROW, { unit = userUnit, x1=x1, y1=y1, facing=facing } )
				
				local newUnit = nil
				local player = userUnit:getPlayerOwner()

				newUnit = simfactory.createUnit( itemdefs.item_translocator_true, sim )
				newUnit:setPlayerOwner( player )
	
				-- Spawn and warp the new unit
				sim:spawnUnit( newUnit )
				sim:warpUnit( newUnit, sim:getCell(x1, y1) )

				sim:emitSound( simdefs.SOUND_ITEM_PUTDOWN, cell.x, cell.y, userUnit)
				sim:emitSound( simdefs.SOUND_PRIME_EMP, cell.x, cell.y, userUnit)

				sim:dispatchEvent( simdefs.EV_UNIT_REFRESH, { unit = newUnit} ) 

				newUnit:getTraits().mainframe_status = "on"
				newUnit:getTraits().isTranslocatorBeacon = true
				newUnit:getTraits().beaconLife = grenadeUnit:getTraits().beaconLifeMax
				newUnit:setPlayerOwner( userUnit:getPlayerOwner() )
				
				userUnit:resetAllAiming()

				inventory.useItem( sim, userUnit, grenadeUnit )

				sim:dispatchEvent( simdefs.EV_UNIT_STOP_THROW, { unitID = userUnit:getID(), x1=x1, y1=y1, facing=facing } )
				--sim:addTrigger( simdefs.TRG_UNIT_WARP, self)

				sim:processReactions( userUnit )
			end
			userUnit:getTraits().throwing = nil
			if userUnit:isValid() and not userUnit:getTraits().interrupted then
				simquery.suggestAgentFacing(userUnit, facing)
			end

			
			
		end,
	}

return sombra_throw_translocator
