---------------------------------------------------------------------
-- Invisible Inc. official DLC.
--

local MOD_STRINGS =
{	           
	
	OPTIONS =
	{
		ENABLE_SOMBRA = "Enable Sombra and items",
		ENABLE_SOMBRA_TIP = "Sombra, hack-master. Uses translocators and cloaking to move around unseen, then blasts opportune targets with her ranged EMP.",  
		ENABLE_WIDOW = "Enable Widowmaker and items",
		ENABLE_WIDOW_TIP = "Widowmaker, master markswoman. Tracks enemies through walls and nullifies them with her twin-state rifle and venom mines.",  
		DISABLE_OVERLAYS = "Disable Overlays",
		DISABLE_OVERLAYS_TIP = "I'm getting bugs with my overlays, turn this on to use them anyway.",  
		DETCENTER = "Spawn In Detention Centers",
		DETCENTER_TIP = "Allows Sombra and Widowmaker to spawn in Detention Centers",  
	},

	AGENTS =
	{
		SOMBRA = {
			NAME = "SOMBRA",
			NAME_LC = "Sombra",
			FILE = "REF Og5-Pm4HNlI",
			YEARS_OF_SERVICE = "??",
			AGE = "30",
			HOMETOWN = "Dorado, Mexico",
			RESCUED = "I was starting to think I'd never get released.",
			BIO_SPOKEN = "",

			ALT_1 = {
				FULLNAME = '-REDACTED-',
				BIO = "Growing up as an orphan of war, --- survived using her natural gift with computers and an aptitude for stealth and distraction. With a life on the streets, it wasn't long before she fell in with a tough crowd.\nWith the alias Sombra, --- dedicated her life to fighting corruption. She revolted against Mexico's government alongside the Los Muertes gang, and recently entered Talon's ranks, seemingly to further her own cause.",
				TOOLTIP = "Infiltrator",
			},

			BANTER = {
				START ={
					"Sombra online.",
					"Everything can be hacked... and everyone.",
					"Let’s get started.",
					"Missed me?",
					"So many targets, so little time.",
					"You have good taste.",
					"I’m securing the objective. Anyone want to join me?",
					"You're taking this very seriously.",
	--				"Iniciando el hackeo.",
					"No more time to waste. Let's get this done!",
					"We've gotten this far, let's not screw it up now.",
					"Clock's ticking...",
					"Boop!",
					"I'm all over it!",
				},
				FINAL_WORDS =
				{
					"Didn’t see that coming.",		
					"Looking for me?",	
					"I'm guessing there's no chance we can take care of this quietly, is there?",
					"We all make mistakes.",
--					"Ya estoy lista para ese trago.", -- = "I'm ready for that drink now" in spanish
					"Don't mind me.",
					"¿Qué tal?",
				},
			},				
		},	
		
		WIDOWMAKER = {
			NAME = "WIDOWMAKER",
			NAME_LC = "Widowmaker",
			FILE = "REF U130wnpi-C0",
			YEARS_OF_SERVICE = "??",
			AGE = "33",
			HOMETOWN = "Annecy, France",
			RESCUED = "Hm, you must like having me around.",
			BIO_SPOKEN = "",

			ALT_1 = {
				FULLNAME = 'Amelie Lacroix',
				BIO = "Wife of fabled agent Gerard Lacroix, Amelie was kidnapped as part of a plot against him. She was eventually rescued by Overwatch and returned to her normal life. Two weeks later she killed Gerard in his sleep.\nHaving been turned into a sleeper agent by Talon, Amelie returned to complete the process of becoming a living weapon. Now known by her handle, Widowmaker is a formidable and remorseless assassin.",
				TOOLTIP = "Marksman",
			},

			BANTER = {
				START ={
					"Widowmaker here.",
					"One shot, one kill.",
					"Enough waiting around.",
					"Widowmaker, au rapport.",
					"I'm ready to kill.",
					"No one can hide from my sight.",
					"Cherchez la femme.",
					"The enemies of Talon will be eliminated.",
					"Victory is so close, I can feel it!",
					"Now, where were we?",
					"At moment of the kill, we are never more alive.",
					"We don't have all day. Hurry up.",
				},
				FINAL_WORDS =
				{
					"A single death can change everything.",		
--					"Et c'est comme ca.",	
					"A la vie, a la mort.",
					"You have my attention.",
					"C'est la vie.",
					"Ah, exquisite!",
				},
			},				
		},	

	},

	ITEMS =
	{
		AUGMENTS =
		{
			-- Ranged EMP/Hack, uses PWR, Noise/AP side effect
			SOMBRAAUG = "Ranged EMP",
			SOMBRAAUG_ICEB = "Ranged EMP",
			SOMBRAAUG_TIP = "Remotely hijack consoles to store charge. Use charge to remotely EMP systems or temporarily open locked Security doors up to 8 tiles away. Uses Charge equal to half the target's Firewall, minimum 1.",
			SOMBRAAUG_FLAVOR = "Sombra's foraminal capacitors and metacarpal relays allow her to quickly overwhelm electronics over a short range. The blast only provides a short window of oppertunity, but often that's all that's needed.",
			SOMBRAAUG_TARGNAME = "EMP {1} for 1 turn",
			SOMBRAAUG_WILLDO = "Will use {1} of {2} stored PWR",
			SOMBRAAUG_STORE_PWR = "STORE PWR",
			SOMBRAAUG_STORE_PWR_DESC = "Store PWR as ammo for Sombra's EMP",
			SOMBRAAUG_CAPACITOR = "Capacitor",
			SOMBRAAUG_CAPACITOR_DESC = "PWR stored in this augment is retained between levels",
			
			-- Reveals unseen enemies on peek, observing movement costs half
			WIDOWSIGHT = "WIDOWSIGHT",
			WIDOWSIGHT_TIP = "Peeking reveals unseen guards within 6 tiles. +1 Ranged Armor Pierce on Observed and Tagged guards",
			WIDOWSIGHT_FLAVOR = "Preferring keeping her targets oblivious until it's too late, Widowmaker's augmented eyesight lets her see enemies through walls and pinpoint the weakspots of targets she tracks.",
			WIDOWSIGHT_NO_AP = "Out of AP",
			PEEK_DESC_WIDOW = "Carefully look around corners.\nPeek through closed doors.\nHighlight enemies within 6 tiles.",

		},
		
		NOTE_ACTION = "USES ACTION",
		NOTE_ACTION_DESC = "This ability counts as an attack",
		
		-- 1ko disruptor + cloak secondary
		SOMBRA_TAZER = "Disruptor Cloak",
		SOMBRA_TAZER_TOOLTIP = "Weak melee. Cloak: 4 tiles.",
		SOMBRA_TAZER_TOOLTIP_KO_DESC = "Knocks a guard out until the start of your next turn",
		SOMBRA_TAZER_TOOLTIP_CLOAKADD = "Secondary Cloak",
		SOMBRA_TAZER_TOOLTIP_CLOAKADD_DESC = "{1} turn cooldown, also triggers Melee Cooldown",
		SOMBRA_TAZER_FLAVOR = "The sleeves of this classic Mark-I cloaking rig have been hooked up to an old disruptor. The setup lacks aggressive utility, but is great for self defense." ,
		SOMBRA_TAZER_REQ_AP = "Requires full AP" ,
		
		-- Cloak Only
		SOMBRA_CLOAK = "Hacked Cloaking Rig",
		SOMBRA_CLOAK_TOOLTIP = "Cloaks user for 6 tiles and grants a 3AP boost.",
		SOMBRA_CLOAK_FLAVOR = "This modified rig doesn't actually last much longer than a traditional one, but provides haptic feedback to help the user plot more effective courses before it over-heats.",
		SOMBRA_CLOAK_SPRINTONLY = "Sprint triggered",
		SOMBRA_CLOAK_SPRINTONLY_DESC = "Once activated, cloaking and item cooldown begin when user sprints to a new tile. No AP requirement.",
		SOMBRA_CLOAK_BONUSMP = "Chameleon Movement",
		SOMBRA_CLOAK_BONUSMP_DESC = "Gain 3 AP when activated.",
		SOMBRA_CLOAK_REQ_SPRINT = "User must be sprinting",
		INVISION = "Cloak would not activate before being shot",
		PREPPED = "CLOAK PREPPED",
		CANCELLED = "CLOAK CANCELLED",
		READY = "Ready Cloak",
		READY_DESC = "Lasts 6 tiles / until end of turn, grants 3 AP. Deactivated by attacking.",
		CANCEL = "Cancel Cloak",
		CANCEL_DESC = "Allows you to sprint without activating cloak",
		
		-- 3 Ammo teleport beacons - destruct after 3 turns
		SOMBRA_TRANSLOCATOR = "Translocator",
		SOMBRA_TRANSLOCATOR_TOOLTIP = "Teleport beacon. Throw to place. Self destructs at end of the following turn.",
		SOMBRA_TRANSLOCATOR_FLAVOR = "Translocators are small anchors that the user can teleport to. Their volatile nature means they rip themselves apart a short time after being activated." ,
		SOMBRA_TRANSLOCATOR_JUMPTO = "Use Translocator",
		SOMBRA_TRANSLOCATOR_JUMPTO_DESC = "Teleport to this location",
		SOMBRA_TRANSLOCATOR_SELFDES = "Self Destruct",
		SOMBRA_TRANSLOCATOR_STATE_1 = "Will destruct end of next turn.",
		SOMBRA_TRANSLOCATOR_STATE_2 = "Will destruct end of this turn.",
		
		-- Bio Dart + Cooker secondary
		WIDOW_RIFLE = "Widow's Kiss",
		WIDOW_RIFLE_TOOLTIP = "Can toggle between Assualt Mode and Sniper mode; Assault Mode uses Charges to deal low KO, while Sniper uses Ammo for an armor piercing kill shot. To use a chargepack, swap to the mode you wish to refill.",
		WIDOW_RIFLE_FLAVOR = "Widow's Rifle can hold two types of ammo: darts for stealth, and a single high-velocity bullet for lethality. The latter requires a steady aim." ,
		WIDOW_RIFLE_TOOLTIP_TOGGLABLE = "Alt Mode",
		WIDOW_RIFLE_TOOLTIP_TOGGLE_A_DESC = "{1} KO, {2} Pierce, {3}/{4} Charges",
		WIDOW_RIFLE_TOOLTIP_TOGGLE_S_DESC = "Lethal, {1} Pierce, {2}/{3} Ammo, -4 AP",
		
		WIDOW_RIFLE_AMMO = "Ammo {1}/{2}",
		WIDOW_RIFLE_AMMO_DESC = "This mode uses live ammunition. It is restocked between missions. Restocking this weapon's ammo mid-mission will not recharge it.",
		
		WIDOW_RIFLE_CHARGES_DESC = "The primary fire of this mode uses Charges./nBoth Charges and Ammo are restocked for this weapon between missions. Recharging this weapon mid-mission will not restock its ammo.",
		WIDOW_RIFLE_CHARGES_DESC_FREE = "This mode uses charges but only regains 1 charge between missions. Recharge using a Charge Pack.",
		
		WIDOW_RIFLE_TOGGLE = "Toggle firing mode",
		WIDOW_RIFLE_TOOLTIP_TOGGLE = "Toggle firing mode",
		WIDOW_RIFLE_TOOLTIP_TOGGLE_ASSAULT_DESC = "Switch to Assault Mode",
		WIDOW_RIFLE_TOOLTIP_TOGGLE_SNIPER_DESC = "Switch to Sniper Mode",
		WIDOW_RIFLE_ASSAULT = "Assault Mode",
		WIDOW_RIFLE_SNIPER = "Sniper Mode",
		WIDOW_RIFLE_TOGGLEMODE = "Swap Mode",
		WIDOW_RIFLE_AP_REQ = "Requires 4AP to use Sniper Mode",
		
		-- 
		WIDOW_MINE = "Venom Mine",
		WIDOW_MINE_TOOLTIP = "Throw to place. Triggers on enemy movement through adjacent squares, distracting and tagging affected guards.",
		WIDOW_MINE_FLAVOR = "This small motion tracker can easily go unnoticed, but unleashes a plume of nano-bots when disturbed." ,

	},

 	ABILITIES = 
 	{
	
		RESTOCK = "Restock",
		RESTOCKABLE = "Bandolier {1}/{2}",
		RESTOCKABLE_DESC = "Charge packs only restore 1 ammo. Recharges 1 ammo between missions.",
		
		USE_CHARGES = "Charges {1}/{2}",
		USE_CHARGES_DESC = "Each use of this item takes a charge. Recharges between missions. Use charge Packs to refill during missions.",		
		
		EMP =
		{
			REQ_LOS = "Requires Line Of Sight",
			IN_DANGER = "Cannot use while in Danger",
			NOT_ENOUGH_AP = "Requires {1} AP to hack from this distance",
			NOT_ENOUGH_CPU = "Requires {1} PWR to hack {2}",
			TOO_ICEY = "Can't cost more than 3 PWR",
			
			CPUCOST = "Equal to Target Icewall",
			MPCOST = "Distance from Target",
			
			CAPTURE_NAME = "HIJACK: {1}",
			HACK_NAME = "EMP: {1}",
			
			NAME = "Wireless EMP",
			NOISE_LVL1 = "{2} PWR, {3} AP, QUIET",
			NOISE_LVL2 = "{2} PWR, {3} AP, LOUD",
			NOISE_LVL3 = "{2} PWR, {3} AP, VERY LOUD",
			CAPTURE_CAM = "{2} PWR, {3} AP, QUIET",
			CAPTURE_CONSOLE = "HIJACK [{1} PWR] +{2} BONUS, {3} AP, QUIET",
			
			TOOLTIP_INFO = "Move Closer to reduce Noise, or Further Away to reduce AP cost. PWR is equal to Target's Firewalls",
			
			NEG_PWR = "-{1} PWR"
			
		},
		
		WIRELESS_SCAN =
		{
		
			UNITINFO = "{1}"
		
		}

	},


}

return MOD_STRINGS
























