-------------------------------------------------------------
local array = include( "modules/array" )
local util = include( "modules/util" )
local cdefs = include( "client_defs" )
local simdefs = include("sim/simdefs")
local simquery = include("sim/simquery")
local speechdefs = include("sim/speechdefs")
local abilityutil = include( "sim/abilities/abilityutil" )
local peek = include( "sim/abilities/peek" )
local inventory = include("sim/inventory")

local widow_peek = util.extend( peek )
	{
		name = STRINGS.ABILITIES.STIM,

		executeAbility = function( self, sim, unit )
			local userUnit = unit:getUnitOwner()

			if unit:getTraits().hasWidowmakerAug then	
				self:performScan( sim, unit )
			end	
			
			peek:executeAbility( sim, unit )
			
		end,
		
		performScan = function( self, sim, abilityOwner )
			local player = abilityOwner:getPlayerOwner()
			local cell = sim:getCell( abilityOwner:getLocation() )
			local maxRange = abilityOwner:getTraits().widowsight_range
			local newGuards = {}
			
			sim:forEachUnit(
				function ( guardUnit )
					local x1, y1 = guardUnit:getLocation()
					if x1 and y1 and guardUnit:getTraits().isGuard --[==[and not guardUnit:getTraits().patrolObserved and not sim:canPlayerSeeUnit( player, guardUnit )]==] then
						local distance = mathutil.dist2d( cell.x, cell.y, x1, y1 )
						if distance < maxRange then   	
							player:glimpseUnit( sim, guardUnit:getID() )
							sim:dispatchEvent( simdefs.EV_UNIT_REFRESH, { unit = guardUnit } )  
							if not sim:canPlayerSeeUnit( player, guardUnit ) and not guardUnit:getTraits().widowTagged_atLeastOnce then
								table.insert( newGuards, guardUnit )
							end
							guardUnit:getTraits().widowTagged = true
						end
					end
				end )
				
			if #newGuards > 0 then
				local newGuard = newGuards[ sim:nextRand( 1, #newGuards ) ]	            
				sim:dispatchEvent( simdefs.EV_CAM_PAN, { newGuard:getLocation() } )	
				sim:dispatchEvent( simdefs.EV_PLAY_SOUND, "SpySociety/Actions/mainframe_object_camera" )
				newGuard:getTraits().widowTagged_atLeastOnce = true
			end	
			
			 --sim:dispatchEvent( simdefs.EV_CAM_PAN, { cell.x, cell.y } )	
		end,
	}
return widow_peek
