local array = include( "modules/array" )
local util = include( "modules/util" )
local mathutil = include( "modules/mathutil" )
local cdefs = include( "client_defs" )
local simdefs = include("sim/simdefs")
local simquery = include("sim/simquery")
local inventory = include("sim/inventory")
local speechdefs = include("sim/speechdefs")
local abilityutil = include( "sim/abilities/abilityutil" )
local mathutil = include( "modules/mathutil" )
local unitdefs = include("sim/unitdefs")
local simfactory = include( "sim/simfactory" )
local itemdefs = include("sim/unitdefs/itemdefs")
local guarddefs = include("sim/unitdefs/guarddefs")
local propdefs = include("sim/unitdefs/propdefs")







-------------------------------------------------------------
-- Stolen from cloak tooltip for showing range - may work with later

local widthrow_tooltip = class( abilityutil.hotkey_tooltip )

function widthrow_tooltip:init( hud, unit, range, ... )
	abilityutil.hotkey_tooltip.init( self, ... )
	self._game = hud._game
	self._unit = unit
	self._range = range
    if range then
        local x0, y0 = unit:getLocation() 
        self._targets = getTargetUnits( hud._game.simCore, unit, x0, y0, range)
    end
end

function widthrow_tooltip:activate( screen )
	abilityutil.hotkey_tooltip.activate( self, screen )
	if self._range then
		local x0, y0 = self._unit:getLocation()
		local coords = simquery.rasterCircle( self._game.simCore, x0, y0, self._range )
		self._hiliteID = self._game.boardRig:hiliteCells( coords, cdefs.HILITE_TARGET_COLOR )
        for i, target in ipairs( self._targets ) do
            self._game.boardRig:getUnitRig( target:getID() ):getProp():setRenderFilter( cdefs.RENDER_FILTERS["focus_target"] )
        end
	end
end

function widthrow_tooltip:deactivate()
	abilityutil.hotkey_tooltip.deactivate( self )
	if self._range then
		self._game.boardRig:unhiliteCells( self._hiliteID )	
		self._hiliteID = nil
        for i, target in ipairs( self._targets ) do
            self._game.boardRig:getUnitRig( target:getID() ):refreshRenderFilter()
        end
	end
end








local widow_throw_mine =
	{
		name = STRINGS.ABILITIES.THROW,

		getName = function( self, sim, unit, userUnit )
			return self.name
		end,
	
		createToolTip = function( self,sim,unit,targetCell)
			return abilityutil.formatToolTip( STRINGS.ABILITIES.THROW,  STRINGS.ABILITIES.THROW_DESC, 1 )
		end,
		
		--onTooltip = function( self, hud, sim, abilityOwner, abilityUser )
		--	return widthrow_tooltip( hud, abilityUser, abilityOwner:getTraits().range, self, sim, abilityOwner, STRINGS.ABILITIES.CLOAK_DESC )
		--end,
	
		profile_icon = "gui/icons/action_icons/Action_icon_Small/icon-item_shoot_small.png",
		usesAction = true,

		acquireTargets = function( self, targets, game, sim, grenadeUnit, unit)
			if not self:canUseAbility( sim, grenadeUnit, unit ) then
				return nil
			end
			return targets.throwTarget( game, grenadeUnit:getTraits().range or 0, sim, unit, unit:getTraits().maxThrow, grenadeUnit:getTraits().targeting_ignoreLOS)
		end, 


		canUseAbility = function( self, sim, grenadeUnit, unit, targetCell )
		
            if unit:getTraits().movingBody then
                return false, STRINGS.UI.REASON.DROP_BODY_TO_USE
            end
			
			local ok, reason = abilityutil.canConsumeAmmo( sim, grenadeUnit )
            if not ok then
                return false
            end

			if grenadeUnit:getTraits().restrictedUse then

				local userUnitAgentID = unit:getUnitData().agentID
				local canUse =false
				for i,set in pairs(grenadeUnit:getTraits().restrictedUse )do
					if set.agentID == userUnitAgentID then
						canUse=true
					end
				end


				if not canUse then
					return false,  STRINGS.UI.REASON.RESTRUCTED_USE
				end				
			end

			if grenadeUnit:getTraits().cooldown and grenadeUnit:getTraits().cooldown > 0 then
				return false, util.sformat(STRINGS.UI.REASON.COOLDOWN,grenadeUnit:getTraits().cooldown)
			end

			if grenadeUnit:getTraits().usesCharges and grenadeUnit:getTraits().charges < 1 then
				return false, util.sformat(STRINGS.UI.REASON.CHARGES)
			end

			if grenadeUnit:getTraits().pwrCost and unit:getPlayerOwner():getCpus() < grenadeUnit:getTraits().pwrCost then
				return false, util.sformat(STRINGS.UI.REASON.NOT_ENOUGH_PWR)
			end

			if targetCell then
				local targetX,targetY = unpack(targetCell)
				local unitX, unitY = unit:getLocation()
	    		local raycastX, raycastY = sim:getLOS():raycast(unitX, unitY, targetX, targetY)
				if raycastX ~= targetX or raycastY ~= targetY then
					return false
				end
				local range = mathutil.dist2d(unitX, unitY, targetX, targetY)
				if range > 5 then
					return false
				end
			end

			return true
		end,

	
		onSpawnAbility = function( self, sim, unit )
			self.abilityOwner = unit
			sim:addTrigger( simdefs.TRG_UNIT_WARP, self)
		end,
			
		onDespawnAbility = function( self, sim, unit )
			sim:removeTrigger( simdefs.TRG_UNIT_WARP, self )
			self.abilityOwner = nil
		end,
		
		onTrigger = function( self, sim, evType, evData )  -- this is unused now but I'm leaving the code here just in case
		
			if evType == simdefs.TRG_UNIT_WARP and evData.unit:getTraits().isGuard then
			local player = sim:getPC()
			local guardUnit = evData.unit
			local cell = evData.to_cell
			local cellb = evData.from_cell
				sim:forEachUnit(
					function ( mineUnit )
						local x1, y1 = mineUnit:getLocation()
						if x1 and y1 and mineUnit:getTraits().isWidowMine then
							if cell and cellb then
								local distance = math.min(mathutil.dist2d( cell.x, cell.y, x1, y1 ), mathutil.dist2d( cellb.x, cellb.y, x1, y1 ))
								local raycastX, raycastY = sim:getLOS():raycast(cell.x, cell.y, x1, y1)
									--if raycastX ~= x or raycastY ~= y then
									--	return false
									--end
						--		if distance <= 4 then
						--			player:glimpseUnit( sim, guardUnit:getID() )
						--			sim:dispatchEvent( simdefs.EV_UNIT_REFRESH, { unit = guardUnit } )     				
						--		end
								if distance <= 1.5 and not (raycastX ~= x1 or raycastY ~= y1) --[==[sim:couldUnitSeeCell( guardUnit, sim:getCell( x1, y1 ) )]==] then
									self:performTrap( sim, cell, guardUnit, mineUnit, player )
								--	sim:removeTrigger( simdefs.TRG_UNIT_WARP, self)								
								end
							end
						end
					end
				)
			end		
	   end,

	   
	   
	 --[==[performTrap = function( self, sim, cell, unit, mineUnit, player )
		--assert( self:getTraits().on_spawn )
		--local sim = self:getSim()
		local newUnit = simfactory.createUnit( unitdefs.lookupTemplate( "smoke_cloud" ), sim )
		sim:spawnUnit( newUnit )
		sim:warpUnit( newUnit, cell )
	end, ]==]
	   
	   -------------------------- Mostly from door traps ----- changed for smoke
	   --[====[ ]====]
	   
	   performTrap = function( self, sim, cell, unit, mineUnit, player )
			-- Remove this trap and its partner.
			--local player = sim:getPC()
			local trapRange = 2
		--	sim:emitSound( simdefs.SOUND_SHOCKTRAP, cell.x, cell.y, nil )	
			sim:dispatchEvent( simdefs.EV_FLASH_VIZ, {x = cell.x, y = cell.y, units = nil, range = 0} )
			sim:dispatchEvent( simdefs.EV_CAM_PAN, { cell.x, cell.y } )	
			local minecell = sim:getCell( mineUnit:getLocation() )
			sim:startTrackerQueue(true)				
			sim:startDaemonQueue()			
			local x1, y1 = mineUnit:getLocation()
			--sim:dispatchEvent( simdefs.EV_UNIT_ALERTED, { unitID = mineUnit:getID() } )

			local dmgt = {ko = true, damage = 1}

			------------------------ spawn smoke cloud ----------------
			--local newUnit = simfactory.createUnit( unitdefs.lookupTemplate( "smoke_cloud_widow" ), sim )
			local prop_templates = include( "sim/unitdefs/propdefs" )
			local unitdefs = include( "sim/unitdefs" )
			local simunit = include( "sim/simunit" )
			--local newUnit = simunit.createUnit( prop_templates.smoke_cloud_widow, sim )
			local newUnit = simfactory.createUnit( unitdefs.lookupTemplate( "smoke_cloud_widow" ), sim )
					sim:spawnUnit( newUnit )
					sim:warpUnit( newUnit, minecell )
			-----------------------------

			--if mineUnit:getTraits().range then
			--		sim:dispatchEvent( simdefs.EV_OVERLOAD_VIZ, {x = x1, y = y1, range = trapRange} )
					local cells = simquery.fillCircle( sim, x1, y1, trapRange, 0)
			--		sim:dispatchEvent( simdefs.EV_KO_GROUP, true )

					for i, cell in ipairs(cells) do
						for i, cellUnit in ipairs( cell.units ) do

							if simquery.isEnemyAgent(player, cellUnit) and not cellUnit:isKO() then
								if cellUnit:getBrain() and not cellUnit:getTraits().tagged then					
									--cellUnit:getTraits().armor = cellUnit:getTraits().armor - 1
							--	elseif cellUnit:getTraits().isDrone and cellUnit.deactivate then
									-- cellUnit:deactivate(sim)
									--cellUnit:setTagged()	

									cellUnit:getTraits().tagged = true
									
									local x1,y1 = cellUnit:getLocation()
									sim:dispatchEvent( simdefs.EV_UNIT_FLOAT_TXT, {txt=STRINGS.UI.FLY_TXT.TAGGED,x=x1,y=y1,color={r=255/255,g=255/255,b=255/255,a=1}} )
									sim:dispatchEvent( simdefs.EV_UNIT_GOALS_UPDATED, { unitID = self:getID() } )	

									cellUnit:getTraits().patrolObserved = true
									
									cellUnit:getBrain():getSenses():addInterest( x1, y1, simdefs.SENSE_HEARING, simdefs.REASON_CAMERA)
								end
							end
						end
					end
				--end

				mineUnitID = mineUnit:getID()
				sim:warpUnit( mineUnit, nil )
				sim:despawnUnit( mineUnit )
				
				--make sure all players glimpse to remove the ghosts
				for i,player in ipairs(sim:getPlayers()) do			
					player:glimpseUnit(sim, mineUnitID)
				end

				sim:startTrackerQueue(false)				
				sim:processDaemonQueue()			
		end,
	   
	   
		-----------------
		
		executeAbility = function( self, sim, grenadeUnit, userUnit, targetCell )
			local sim = grenadeUnit:getSim()
			local x0,y0 = userUnit:getLocation()
					
			local x1,y1 = unpack(targetCell)
			local cell = sim:getCell( userUnit:getLocation() )
			userUnit:getTraits().throwing = true
		
			local facing = simquery.getDirectionFromDelta(x1-x0, y1-y0)
			simquery.suggestAgentFacing(userUnit, facing)
			if userUnit:getBrain() then	
				if grenadeUnit:getTraits().baseDamage then
					sim:emitSpeech(userUnit, speechdefs.HUNT_GRENADE)
				end
				sim:refreshUnitLOS( userUnit )
				sim:processReactions( userUnit )
			end

			if userUnit:isValid() and not userUnit:getTraits().interrupted then
			
			--sim:removeTrigger( simdefs.TRG_UNIT_WARP, self )
			
			--[==[------------
			local player = sim:getPC()
			sim:forEachUnit(
					function ( existingMines )
						local x1, y1 = existingMines:getLocation()
						if x1 and y1 and existingMines:getTraits().isWidowMine then
							mineUnitID = existingMines:getID()				
							sim:warpUnit(existingMines, nil)
							sim:despawnUnit( existingMines )
							player:glimpseUnit(sim, mineUnitID)
							sim:removeTrigger( simdefs.TRG_UNIT_WARP, self)
						end
					end
				)
			]==]------------
			
				--sim:dispatchEvent( simdefs.EV_UNIT_START_SHOOTING, { unitID = userUnit:getID(), newFacing = newFacing, oldFacing = oldFacing, overwatch = true, targetUnitID = targetUnit:getID() } )
				sim:dispatchEvent( simdefs.EV_UNIT_THROW, { unit = userUnit, x1=x1, y1=y1, facing=facing } )
				--sim:dispatchEvent( simdefs.EV_UNIT_STOP_SHOOTING, { unitID = userUnit:getID(), facing=facing } )	
				

				local newUnit = nil
				local player = userUnit:getPlayerOwner()

				newUnit = simfactory.createUnit( itemdefs.item_venommine_true, sim )
				newUnit:setPlayerOwner( player )
	
				-- Spawn and warp the new unit
				sim:spawnUnit( newUnit )
				sim:warpUnit( newUnit, sim:getCell(x1, y1) )

				sim:emitSound( simdefs.SOUND_ITEM_PUTDOWN, cell.x, cell.y, userUnit)
			sim:emitSound( simdefs.SOUND_PRIME_EMP, cell.x, cell.y, userUnit)
			
			--self.abilityOwner = userUnit
			--sim:addTrigger( simdefs.TRG_UNIT_WARP, self )
			
			

			sim:dispatchEvent( simdefs.EV_UNIT_REFRESH, { unit = newUnit} ) 

			--if newUnit:getTraits().trigger_mainframe then
				--newUnit:getTraits().mainframe_item = true
				newUnit:getTraits().mainframe_status = "on"
				newUnit:getTraits().isWidowMine = true
				newUnit:setPlayerOwner( userUnit:getPlayerOwner() )
			--end
				
				userUnit:resetAllAiming()

			inventory.useItem( sim, userUnit, grenadeUnit )

				sim:dispatchEvent( simdefs.EV_UNIT_STOP_THROW, { unitID = userUnit:getID(), x1=x1, y1=y1, facing=facing } )
			-- sim:addTrigger( simdefs.TRG_UNIT_WARP, self)

				sim:processReactions( userUnit )
			end
			userUnit:getTraits().throwing = nil
			if userUnit:isValid() and not userUnit:getTraits().interrupted then
				simquery.suggestAgentFacing(userUnit, facing)
			end

			
			
		end,
	}

return widow_throw_mine
